# -*- coding:Utf-8 -*-
# dm_python V2.101p (2010/06/15) by DoCky


import es, psyco, random, gamethread, cfglib, langlib, playerlib, weaponlib
try: import simplemenulib
except ImportError: raise ImportError, "cannot import library Simplemenulib"
try: from spe.games import cstrike as es_spe
except ImportError: es.dbgmsg(1, "dm_python: cannot use plugin Source Python Extensions")

from dm_votemap import DmVotemap
from dm_config import DmConfig
from dm_weapon import DmWeapon
from dm_player import DmPlayer
from dm_spawns import DmSpawns
psyco.full()


esInfo = es.AddonInfo()
esInfo.author = "DoCky"
esInfo.version = "2.101p"
esInfo.date = "2010/06/15"
esInfo.basename = "dm_python"
esInfo.name = "Deathmatch Python"
esInfo.url = "http://addons.eventscripts.com/addons/user/11751"

version = es.ServerVar("dm_python", "", " Created by DoCy -")
version.set(esInfo.version)
version.makepublic()
player = {}


############################
# MENU
def menuMain():
    # create deathmatch menu
    try: timeout = int(config.timeout)
    except ValueError: timeout = 0
    menu = simplemenulib.menu("_dm_python_categorie_menu")
    menu.loadlang("cfg/dm_python/language/deathmatch_menu.ini")
    menu.title("main menu title", showpage = False)

    if weapon.pistol:
        menu.addchoice("main option pistol")
        menu.subsimplemenu("main option pistol", "_dm_python_pistol_menu")
        menuConstruct("_dm_python_pistol_menu", "pistol menu title", timeout, weapon.pistol)

    if weapon.shotgun:
        menu.addchoice("main option shotgun")
        menu.subsimplemenu("main option shotgun", "_dm_python_shotgun_menu")
        menuConstruct("_dm_python_shotgun_menu", "shotgun menu title", timeout, weapon.shotgun)

    if weapon.smg:
        menu.addchoice("main option smg")
        menu.subsimplemenu("main option smg", "_dm_python_smg_menu")
        menuConstruct("_dm_python_smg_menu", "smg menu title", timeout, weapon.smg)

    if weapon.rifle:
        menu.addchoice("main option rifle")
        menu.subsimplemenu("main option rifle", "_dm_python_rifle_menu")
        menuConstruct("_dm_python_rifle_menu", "rifle menu title", timeout, weapon.rifle)

    if weapon.sniper:
        menu.addchoice("main option sniper")
        menu.subsimplemenu("main option sniper", "_dm_python_sniper_menu")
        menuConstruct("_dm_python_sniper_menu", "sniper menu title", timeout, weapon.sniper)

    menu.addlist("_dm_python_deathmatch_menu")
    menu.addlist("_dm_python_list_menu")
    menu.timeout("view", timeout)

def menuConstruct(menuId, menuTitle, menuTimeout, weaponList):
    menu = simplemenulib.menu(menuId)
    menu.loadlang("cfg/dm_python/language/deathmatch_menu.ini")
    menu.title(menuTitle, showpage = False)
    for weaponName in weaponList:
        choice = "menu option %s" % weaponName
        menu.addchoice(choice, "weapon_" + weaponName)
        menu.subsimplemenu(choice, "_dm_python_categorie_menu")

    menu.simplemenureturn("_dm_python_categorie_menu")
    menu.addlist("_dm_python_deathmatch_menu")
    menu.addlist("_dm_python_list_menu")
    menu.timeout("view", menuTimeout)
    menu.blockselect = menuWeapon

def menuWeapon(userid, index, choice, value, name, page):
    if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
        weaponSlot = weaponlib.getWeapon(value).slot
        if weaponSlot == 1:
            weaponDrop = str(playerlib.getPlayer(userid).primary)
            player[userid].primary = value
        else:
            weaponDrop = str(playerlib.getPlayer(userid).secondary)
            player[userid].secondary = value

        if weaponDrop <> value:
            if weaponDrop <> "0":
                es.sexec(userid, "use " + weaponDrop)
                es.sexec(userid, "drop")
            es.server.queuecmd("es_xgive %s %s" % (userid, value))


############################
# ADMIN
def menuAdmin():
    # main
    menu = simplemenulib.menu("_dm_python_Administration_menu")
    menu.loadlang("cfg/dm_python/language/Administration_menu.ini")
    menu.title("admin main title", showpage = False)
    menu.addchoice("admin configuration option")
    menu.subsimplemenu("admin configuration option", "_dm_python_configuration_menu")
    menu.addchoice("admin items option")
    menu.subsimplemenu("admin items option", "_dm_python_items_menu")
    menu.addchoice("admin votemap option")
    menu.subsimplemenu("admin votemap option", "_dm_python_votemap_menu")
    menu.addchoice("admin restrict option")
    menu.subsimplemenu("admin restrict option", "_dm_python_restrict_menu")
    menu.addchoice("admin spawnpoint option")
    menu.addlist("_dm_python_list_menu")
    menu.blockselect = menuAdministration

    # configuration
    menu = simplemenulib.menu("_dm_python_configuration_menu")
    menu.loadlang("cfg/dm_python/language/Administration_menu.ini")
    menu.title("admin configuration title", showpage = False)
    menu.addchoice("configuration administration command", ("config imputbox admin", config.admin, "_dp_cvar_admin"))
    menu.subsimplemenu("configuration administration command", "_dm_python_configuration_menu")
    menu.addchoice("configuration deathmatch command", ("config imputbox command", config.command, "_dp_cvar_command"))
    menu.subsimplemenu("configuration deathmatch command", "_dm_python_configuration_menu")
    menu.addchoice("configuration menu timeout", ("config imputbox timeout", config.timeout, "_dp_cvar_timeout"))
    menu.subsimplemenu("configuration menu timeout", "_dm_python_configuration_menu")
    menu.addchoice("configuration respawn method", ("config imputbox method", config.method, "_dp_cvar_method"))
    menu.subsimplemenu("configuration respawn method", "_dm_python_configuration_menu")
    menu.addchoice("configuration respawn random", ("config imputbox random", config.random, "_dp_cvar_random"))
    menu.subsimplemenu("configuration respawn random", "_dm_python_configuration_menu")
    menu.addchoice("configuration respawn time", ("config imputbox respawn", config.respawn, "_dp_cvar_respawn"))
    menu.subsimplemenu("configuration respawn time", "_dm_python_configuration_menu")
    menu.addchoice("configuration Ragdoll dissolver", ("config imputbox dissolver", config.dissolver, "_dp_cvar_dissolver"))
    menu.subsimplemenu("configuration Ragdoll dissolver", "_dm_python_configuration_menu")
    menu.simplemenureturn("_dm_python_Administration_menu")
    menu.addlist("_dm_python_list_menu")
    menu.blockselect = menuValue

    # items
    menu = simplemenulib.menu("_dm_python_items_menu")
    menu.loadlang("cfg/dm_python/language/Administration_menu.ini")
    menu.title("admin items title", showpage = False)
    menu.addchoice("items give assaultsuit", ("items imputbox assaultsuit", config.assaultsuit, "_dp_cvar_assaultsuit"))
    menu.subsimplemenu("items give assaultsuit", "_dm_python_items_menu")
    menu.addchoice("items give nightvision", ("items imputbox nightvision", config.nightvision, "_dp_cvar_nightvision"))
    menu.subsimplemenu("items give nightvision", "_dm_python_items_menu")
    menu.addchoice("items hegrenade max", ("items imputbox hegrenade", config.hegrenade, "_dp_cvar_hegrenade"))
    menu.subsimplemenu("items hegrenade max", "_dm_python_items_menu")
    menu.addchoice("items flashbang max", ("items imputbox flashbang", config.flashbang, "_dp_cvar_flashbang"))
    menu.subsimplemenu("items flashbang max", "_dm_python_items_menu")
    menu.addchoice("items smokegrenade max", ("items imputbox smokegrenade", config.smokegrenade, "_dp_cvar_smokegrenade"))
    menu.subsimplemenu("items smokegrenade max", "_dm_python_items_menu")
    menu.simplemenureturn("_dm_python_Administration_menu")
    menu.addlist("_dm_python_list_menu")
    menu.blockselect = menuValue

    # votemap
    menu = simplemenulib.menu("_dm_python_votemap_menu")
    menu.loadlang("cfg/dm_python/language/Administration_menu.ini")
    menu.title("admin votemap title", showpage = False)
    menu.addchoice("votemap vote kills", ("votemap imputbox kills", config.kills, "_dp_cvar_kills"))
    menu.subsimplemenu("votemap vote kills", "_dm_python_votemap_menu")
    menu.addchoice("votemap vote time", ("votemap imputbox time", config.time, "_dp_cvar_time"))
    menu.subsimplemenu("votemap vote time", "_dm_python_votemap_menu")
    menu.addchoice("votemap max map", ("votemap imputbox maxmap", config.maxmap, "_dp_cvar_maxmap"))
    menu.subsimplemenu("votemap max map", "_dm_python_votemap_menu")
    menu.addchoice("votemap last maps", ("votemap imputbox lastmaps", config.lastmaps, "_dp_cvar_lastmaps"))
    menu.subsimplemenu("votemap last maps", "_dm_python_votemap_menu")
    menu.simplemenureturn("_dm_python_Administration_menu")
    menu.addlist("_dm_python_list_menu")
    menu.blockselect = menuValue

    # restriction
    menu = simplemenulib.menu("_dm_python_restrict_menu")
    menu.loadlang("cfg/dm_python/language/Administration_menu.ini")
    menu.title("admin restrict title")
    for weaponName in weapon.weaponlist: menu.addchoice("restrict weapon " + weaponName, weaponName, underline = True if weaponName in weapon else False)
    menu.simplemenureturn("_dm_python_Administration_menu")
    menu.addlist("_dm_python_list_menu")
    menu.blockselect = menuRestrict

    # spawnpoint
    menu = simplemenulib.menu("_dm_python_spawnpoint_menu")
    menu.loadlang("cfg/dm_python/language/Administration_menu.ini")
    menu.title("admin spawnpoint title", showpage = False)
    menu.addchoice("spawnpoint noclip status")
    menu.addchoice("spawnpoint add position")
    menu.addchoice("spawnpoint move current")
    menu.subsimplemenu("spawnpoint move current", "_dm_python_spawnpoint_menu")
    menu.addchoice("spawnpoint move next")
    menu.addchoice("spawnpoint move back")
    menu.addchoice("spawnpoint del current")
    menu.addchoice("spawnpoint show spawnpoints")
    menu.subsimplemenu("spawnpoint show spawnpoints", "_dm_python_spawnpoint_menu")
    menu.simplemenureturn("_dm_python_Administration_menu")
    menu.addlist("_dm_python_list_menu")
    menu.blockselect = menuSpawnpoint

def menuAdministration(userid, index, choice, value, name, page):
    if index == 5:
        if es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
            simplemenulib.send(userid, name)
            es.tell(userid, "#multi", messagePlayer(userid, "admin alive message"))
        else: spawnpointUpdate(userid, lastspawn = True)

""" configuration, equipment and votemap """
def menuValue(userid, index, choice, value, name, page):
    boxmsg, value, command = value
    es.tell(userid, "#multi", messagePlayer(userid, "escmenu imputbox message"))
    es.escinputbox(20, userid, messagePlayer(userid, boxmsg), messagePlayer(userid, "escmenu imputbox currentvalue", {"value" : value}), command)

""" restriction """
def menuRestrict(userid, index, choice, value, name, page):
    menu = simplemenulib.find(name)
    if value in weapon:
        weapon - value
        menu.modchoice(choice, choice, value, underline = False)
    else:
        weapon + value
        menu.modchoice(choice, choice, value, underline = True)
    menu.send(userid, page)

    usersmenu = {}
    deathmatch = simplemenulib.getlist("_dm_python_deathmatch_menu")
    for userid in player:
        name = simplemenulib.active(userid)["name"]
        if name in deathmatch:
            usersmenu[userid] = name
            simplemenulib.close(userid, name)

    simplemenulib.dellist("_dm_python_deathmatch_menu")
    weapon.save()
    weapon.read()
    menuMain()

    for userid, name in usersmenu.items():
        if simplemenulib.exists(name): simplemenulib.send(userid, name)
        else: simplemenulib.send(userid, "_dm_python_categorie_menu")
        es.tell(userid, "#multi", messagePlayer(userid, "deathmatch menu updated"))

""" spawnpoints """
def menuSpawnpoint(userid, index, choice, value, name, page):
    if index == 1:
        user = playerlib.getPlayer(userid)
        menu = simplemenulib.find(name)
        noclip = bool(user.noclip)
        if noclip:
            user.noclip = False
            menu.modchoice(choice, choice, underline = False)
        else:
            user.noclip = True
            menu.modchoice(choice, choice, underline = True)
        menu.send(userid)

    elif index == 2:
        spawns.add(userid, es.getplayerteam(userid))
        user = player[userid]
        user.indexspawn += 1
        spawnpointUpdate(userid)

    elif index == 3: spawns.set(userid, player[userid].indexspawn, es.getplayerteam(userid))
    elif index == 4:
        team = es.getplayerteam(userid)
        spawnlist = spawns.terrorist if team == 2 else spawns.counterterrorist
        spawncount = len(spawnlist)
        if spawncount:

            user = player[userid]
            if user.indexspawn + 1 < spawncount: user.indexspawn += 1
            else: user.indexspawn = 0
            spawns.set(userid, user.indexspawn, team)
        spawnpointUpdate(userid)

    elif index == 5:
        team = es.getplayerteam(userid)
        spawnlist = spawns.terrorist if team == 2 else spawns.counterterrorist
        spawncount = len(spawnlist)
        if spawncount:

            user = player[userid]
            if user.indexspawn > 0: user.indexspawn -= 1
            else: user.indexspawn = spawncount - 1 if spawncount else 0
            spawns.set(userid, user.indexspawn, team)
        spawnpointUpdate(userid)

    elif index == 6:
        team = es.getplayerteam(userid)
        spawnlist = spawns.terrorist if team == 2 else spawns.counterterrorist
        user = player[userid]

        if user.indexspawn > -1:
            spawns.sub(user.indexspawn, team)
            user.indexspawn -= 1
        if user.indexspawn < 0:
            spawncount = len(spawnlist)
            user.indexspawn = spawncount - 1 if spawncount else -1
        spawnpointUpdate(userid)
    elif index == 7: spawns.show(es.getplayerteam(userid))


############################
# VOTE
def voteSubmit():
    maplist = votemap.get()
    if maplist and [user for user in es.getUseridList() if not es.isbot(user)]:
        vote = simplemenulib.vote("_dm_python_deathmatch_vote")
        vote.loadlang("cfg/dm_python/language/deathmatch_vote.ini")
        vote.question("deathmatch vote title", showpage = True if len(maplist) > 8 else False)
        for mapname in maplist: vote.addanswer("deathmatch vote answer", mapname, {"$mapname" : mapname})
        vote.blockendvote = voteEnd
        vote.submit(time = int(config.time), prio = True)
        global mapIsVoted
        mapIsVoted = True

def voteEnd(answer, value, votes, total, players, percent, votename):
    if value:
        gamethread.delayed(5, voteChangeLevel, value)
        for user in es.getUseridList():
            es.tell(user, "#multi", messagePlayer(user, "deathmatch vote win", {"nextmap" : value}))

def voteChangeLevel(level):
    userid = es.getuserid()
    es.forcevalue("eventscripts_nextmapoverride", level)
    if not userid: es.server.queuecmd("nextlevel %s;endround" % level)
    else: es.server.queuecmd("es_xentcreate %s game_end;es_xfire %s game_end endgame" % (userid, userid))


############################
# FUNCTION
""" initialization """
def init():
    global language, mapIsVoted
    language = langlib.Strings(es.getString("eventscripts_gamedir") + "/cfg/dm_python/language/deathmatch_strings.ini")
    gamethread.delayed(2, spawns.search)

    mapIsVoted = False
    removeObjectives()
    config.execCfg()
    config.createCmd()
    weapon.read()
    votemap.read()
    votemap.new()
    player.clear()
    menuAdmin()
    menuMain()

    for userid in es.getUseridList():
        player[userid] = DmPlayer(userid)
        if es.getplayerteam(userid) > 1: respawnPlayer(userid)

""" respawn a player """
def respawnPlayer(userid):
    if es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
        plugin = str(config.method).lower()
        if plugin == "sp_extensions": es_spe.respawn(int(userid))
        elif plugin == "es_tools": es.server.queuecmd("est_spawn %s" % userid)
        else: es.dbgmsg(0, 'dm_python: cannot use plugin "%s" for respawn userid "%s"' % (plugin, userid))
        spawn = spawns.get(int(config.random), es.getplayerteam(userid))
        if spawn is not None:
            ox, oy, oz, ax, ay, az = spawn
            es.server.queuecmd("es_xsetpos %s %s %s %s;es_xsetang %s %s %s %s" % (userid, ox, oy, oz, userid, ax, ay, az))

""" remove objectives """
def removeObjectives():
    userid = es.getuserid()
    es.server.queuecmd(
        "es_xfire %s func_hostage_* kill;" % userid +
        "es_xfire %s hostage_entity kill;" % userid +
        "es_xfire %s func_bomb_* kill;" % userid +
        "es_xfire %s weapon_c4 kill" % userid)

""" change convars value """
def cvarValue():
    userid = es.getcmduserid()
    if es.getplayersteamid(userid) in config:
        value = es.getargv(1)
        if value:

            name = es.getargv(0).replace("_dp_cvar_", "")
            cvar, values = config[name]
            if isinstance(values, int):
                try: cvar.set(abs(int(value)))
                except ValueError: es.tell(userid, "#multi", messagePlayer(userid, "escmenu imputbox wrongint"))

            elif isinstance(values, tuple):
                if value in values: cvar.set(value)
                else: es.tell(userid, "#multi", messagePlayer(userid, "escmenu imputbox wrongvalue", {"values" : "#default|".join(map(lambda value: "#lightgreen" + value, values))}))
            else: cvar.set(value)

            if name == "admin" or name == "command": config.createCmd()
            elif name == "timeout": menuMain()

""" check score for vote """
def playerScore():
    kills = int(config.kills)
    if kills:
        for attrib in es.createplayerlist().values():
            if attrib["kills"] >= kills: voteSubmit()

""" get message from langlib of deathmatch_strings.ini """
def messagePlayer(userid, section, tokens = {}):
    lang = player[userid].lang
    return language(section, tokens, lang if language[section].has_key(lang) else "en")

""" menu command """
def deathmatchMenu():
    userid = es.getcmduserid()
    if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
        menu = simplemenulib.active(userid)["name"]
        if menu in simplemenulib.getlist("_dm_python_list_menu"): simplemenulib.close(userid, menu)
        simplemenulib.send(userid, "_dm_python_categorie_menu")
        player[userid].firstspawn = False

def AdministrationMenu():
    userid = es.getcmduserid()
    steamid = es.getplayersteamid(userid)
    if steamid in config:
        menu = simplemenulib.active(userid)["name"]
        if menu in simplemenulib.getlist("_dm_python_list_menu"): simplemenulib.close(userid, menu)
        AdministrationUpdate(userid)

""" menu update """
def AdministrationUpdate(userid):
    menu = simplemenulib.find("_dm_python_Administration_menu")
    if es.getplayerprop(userid, "CBasePlayer.pl.deadflag"): menu.modchoice("admin spawnpoint option", "admin spawnpoint option", underline = False)
    else: menu.modchoice("admin spawnpoint option", "admin spawnpoint option")
    if menu.isqueued(userid, 1): menu.close(userid)
    menu.send(userid)

def spawnpointUpdate(userid, lastspawn = False):
    spawnlist = spawns.terrorist if es.getplayerteam(userid) == 2 else spawns.counterterrorist
    user = player[userid]
    if lastspawn: user.indexspawn = len(spawnlist) - 1
    menu = simplemenulib.find("_dm_python_spawnpoint_menu")
    menu.title("admin spawnpoint title", {"$number" : user.indexspawn + 1}, False)

    if bool(playerlib.getPlayer(userid).noclip): menu.modchoice("spawnpoint noclip status", "spawnpoint noclip status", underline = True)
    else: menu.modchoice("spawnpoint noclip status", "spawnpoint noclip status", underline = False)

    if spawnlist:
        menu.modchoice("spawnpoint move current", "spawnpoint move current", underline = True)
        menu.modchoice("spawnpoint move next", "spawnpoint move next", underline = True)
        menu.modchoice("spawnpoint move back", "spawnpoint move back", underline = True)
        menu.modchoice("spawnpoint del current", "spawnpoint del current", underline = True)
        menu.modchoice("spawnpoint show spawnpoints", "spawnpoint show spawnpoints", underline = True)

    else:
        menu.modchoice("spawnpoint move current", "spawnpoint move current", underline = False)
        menu.modchoice("spawnpoint move next", "spawnpoint move next", underline = False)
        menu.modchoice("spawnpoint move back", "spawnpoint move back", underline = False)
        menu.modchoice("spawnpoint del current", "spawnpoint del current", underline = False)
        menu.modchoice("spawnpoint show spawnpoints", "spawnpoint show spawnpoints", underline = False)
    menu.send(userid)


############################
# EVENT
def unload():
    spawns.save()
    config.unload()
    for user in player.values(): user.unload()
    simplemenulib.dellist("_dm_python_list_menu")
    if simplemenulib.exists("_dm_python_deathmatch_vote"): simplemenulib.delete("_dm_python_deathmatch_vote")

def load():
    global config, weapon, spawns, votemap
    config, weapon, spawns, votemap = DmConfig(), DmWeapon(), DmSpawns(), DmVotemap()
    init()

def es_map_start(event):
    config.saveCfg()
    spawns.save()
    init()

def round_start(event):
    gamethread.delayed(1, removeObjectives)


def player_disconnect(event):
    userid = int(event["userid"])
    if player.has_key(userid): del player[userid]

def player_spawn(event):
    userid = int(event["userid"])
    if not player.has_key(userid): player[userid] = DmPlayer(userid)
    if not es.getplayerprop(userid, "CBasePlayer.pl.deadflag"): player[userid].spawn(event["es_userteam"])

def player_team(event):
    if int(event["team"]) > 1: gamethread.delayed(2, respawnPlayer, event["userid"])

def player_death(event):
    userid = int(event["userid"])
    try:
        time = int(config.respawn)
        gamethread.delayed(time if time > 0 else 1, respawnPlayer, userid)
    except ValueError: gamethread.delayed(1, respawnPlayer, userid)

    if int(config.dissolver):
        es.server.queuecmd(
            "es_xfire %s env_entity_dissolver kill;" % userid +
            "es_xentcreate %s env_entity_dissolver;" % userid +
            'es_xfire %s env_entity_dissolver addoutput "target cs_ragdoll";' % userid +
            'es_xfire %s env_entity_dissolver addoutput "magnitude 1";' % userid +
            'es_xfire %s env_entity_dissolver addoutput "dissolvetype %s";' % (userid, random.randint(0,3)) +
            "es_xfire %s env_entity_dissolver dissolve;" % userid)

    else: es.server.queuecmd("es_xfire %s cs_ragdoll kill" % userid)
    if simplemenulib.isqueued(userid, "_dm_python_Administration_menu", 1): AdministrationUpdate(userid)
    elif simplemenulib.isqueued(userid, "_dm_python_spawnpoint_menu", 1):
        es.tell(userid, "#multi", messagePlayer(userid, "admin alive message"))
        simplemenulib.close(userid, "_dm_python_spawnpoint_menu")
        AdministrationUpdate(userid)
    if not mapIsVoted: playerScore()


def item_pickup(event):
    userid, item = event["userid"], event["item"]
    if item <> "knife":
        if not item in weapon:
            itemInfo = weaponlib.getWeapon(item)
            if itemInfo is not None: es.server.queuecmd("es_xfire %s %s kill" % (userid, itemInfo.name))

def hegrenade_detonate(event):
    userid = int(event["userid"])
    user = player[userid]
    user.hegrenade += 1
    if user.hegrenade < int(config.hegrenade): es.server.queuecmd("es_xgive %s weapon_hegrenade" % userid)

def flashbang_detonate(event):
    userid = int(event["userid"])
    user = player[userid]
    user.flashbang += 1
    if user.flashbang < int(config.flashbang): es.server.queuecmd("es_xgive %s weapon_flashbang" % userid)

def smokegrenade_detonate(event):
    userid = int(event["userid"])
    user = player[userid]
    user.smokegrenade += 1
    if user.smokegrenade < int(config.smokegrenade): es.server.queuecmd("es_xgive %s weapon_smokegrenade" % userid)
