# -*- coding:Utf-8 -*-
import es, os, psyco, random, cPickle, playerlib, effectlib, gamethread
psyco.full()


class DmSpawns(object):
    """ Spawns Management """

    def __init__(self):
        self.spawns = {}
        self.terrorist = []
        self.counterterrorist = []
        self.isviewing = False
        self.map = es.ServerVar("eventscripts_currentmap")
        self.file = es.getString("eventscripts_gamedir") + "/addons/eventscripts/dm_python/spawnpoints.ini"

        if not os.path.isfile(self.file): self.save()
        try:
            spawnfile = open(self.file, "rb")
            self.spawns = cPickle.load(spawnfile)
            spawnfile.close()
        except IOError: es.dbgmsg(0, "dm_python: cannot load file addons/eventscripts/dm_python/spawnpoints.ini")

    def search(self):
        mapname = str(self.map)
        if not self.spawns.has_key(mapname):
            self.spawns[mapname] = ([], [])
            self.terrorist, self.counterterrorist = self.spawns[mapname]
            for index in es.createentitylist("info_player_terrorist"): self.terrorist.append(
                map(float, es.getindexprop(index, "CBaseEntity.m_vecOrigin").split(",")) + map(float, es.getindexprop(index, "CBaseEntity.m_angRotation").split(",")))
            for index in es.createentitylist("info_player_counterterrorist"): self.counterterrorist.append(
                map(float, es.getindexprop(index, "CBaseEntity.m_vecOrigin").split(",")) + map(float, es.getindexprop(index, "CBaseEntity.m_angRotation").split(",")))
        else: self.terrorist, self.counterterrorist = self.spawns[mapname]

    def save(self):
        try:
            spawnfile = open(self.file, "wb")
            cPickle.dump(self.spawns, spawnfile)
            spawnfile.close()
        except IOError: es.dbgmsg(0, "dm_python: cannot save file addons/eventscripts/dm_python/spawnpoints.ini")

    def add(self, userid, team):
        user = playerlib.getPlayer(userid)
        ax, ay, az = user.viewangle
        ox, oy, oz = user.location
        spawns = self.terrorist if team == 2 else self.counterterrorist
        spawns.append((ox, oy, oz, ax, ay, az))
        self.i_effect([ox, oy, oz], "red" if team == 2 else "blue")

    def sub(self, index, team):
        spawns = self.terrorist if team == 2 else self.counterterrorist
        ox, oy, oz, ax, ay, az = spawns[index]
        self.i_effect([ox, oy, oz], "white")
        del spawns[index]

    def set(self, userid, index, team):
        try:
            spawns = self.terrorist if team == 2 else self.counterterrorist
            ox, oy, oz, ax, ay, az = spawns[index]
            es.server.queuecmd("es_xsetpos %s %s %s %s;es_xsetang %s %s %s %s" % (userid, ox, oy, oz, userid, ax, ay, az))
            self.i_effect([ox, oy, oz], "green")
        except IndexError: pass

    def get(self, rand, team):
        if rand: spawns = self.terrorist + self.counterterrorist
        else: spawns = self.terrorist if team == 2 else self.counterterrorist
        return random.choice(spawns) if spawns else None

    def show(self, team):
        gamethread.cancelDelayed("_dm_python_shw_spawnpoints") 
        spawns = self.terrorist if team == 2 else self.counterterrorist
        self.i_show(spawns, 0, "red" if team == 2 else "blue")

    def i_show(self, spawns, current, color):
        try:
            ox, oy, oz, ax, ay, az = spawns[current]
            self.i_effect([ox, oy, oz], color)
            gamethread.delayedname(0.01, "_dm_python_shw_spawnpoints", self.i_show, (spawns, current + 1, color))
        except IndexError: pass

    def i_effect(self, coord1, color):
        coord2 = coord1[:]
        coord1[0] -= 30
        coord1[1] += 30
        coord2[0] += 30
        coord2[1] -= 30
        coord2[2] += 100
        if color == "red": effectlib.drawBox(coord1, coord2, seconds = 2, width = 5, endwidth = 5, green = 0, blue = 0)
        elif color == "blue": effectlib.drawBox(coord1, coord2, seconds = 2, width = 5, endwidth = 5, green = 0, red = 0)
        elif color == "green": effectlib.drawBox(coord1, coord2, seconds = 2, width = 5, endwidth = 5, red = 0, blue = 0)
        elif color == "white": effectlib.drawBox(coord1, coord2, seconds = 2, width = 5, endwidth = 5)
